<?php

Yii::import('ext.signal.PSignalManager');
class PPhpSignalManager extends PSignalManager 
{
    const KEY_PREFIX = 'PSignalManager_';
    public $dataDirectory;
    
    public function getSignalsKey()
    {
        return self::KEY_PREFIX . 'signals';
    }
    
    public function getConfigFilesKey()
    {
        return self::KEY_PREFIX . 'configFiles';
    }
    
    public function getRecieversKey($name)
    {
        return self::KEY_PREFIX . 'recievers_'.$name;
    }
    
	public function init()
	{
		parent::init();
		if ($this->dataDirectory === null) {
		    $this->dataDirectory = Yii::getPathOfAlias('application.data.signals');
		}
		$this->registerSignalRecievers();
	}
	
	protected function clearPersister($path = null)
	{
		if($path === null)
			$path = $this->dataDirectory;
		if(($handle = opendir($path)) === false)
			return;
		while(($file=readdir($handle)) !== false)
		{
			if($file[0]==='.')
				continue;
			$fullPath = $path.DIRECTORY_SEPARATOR.$file;
			if(is_dir($fullPath))
				$this->clearAllFiles($fullPath);
			else 
                @unlink($fullPath);
		}
		closedir($handle);
	}
	
	public function load($key)
	{
	    $file = $this->dataDirectory . DIRECTORY_SEPARATOR . $key.'.php';
		if(is_file($file))
			return @unserialize(file_get_contents($file));
		else
			return false;
	}
	
	public function save($key, $data)
	{
	    $file = $this->dataDirectory . DIRECTORY_SEPARATOR . $key.'.php';
	    file_put_contents($file, serialize($data), LOCK_EX);
	}
}